      subroutine begincolsq(unit,ncls)
c----------------------------------------------------------------------c
c Begins writing for colsqkk.f
c----------------------------------------------------------------------c

      use extpart

      implicit none

      integer :: unit,ncls,i
      character(80) :: ind1,ind2

      write(unit,'(a)') '      subroutine colsqkk(cfd2,rdgs)'
      write(unit,'(a)') 'c============================================='
     &                             //'================================c'
      write(unit,'(a)') 'c Calculates colour factors'
      write(unit,'(a)') 'c============================================='
     &                             //'================================c'
      write(unit,'(a)') ' '
      write(unit,'(a)') '      integer :: rdgs'
      write(ind1,'(i16)') ncls
      write(unit,'(a)') '      integer, parameter :: ncls='
     &                                 //trim(adjustl(ind1))
      write(unit,'(a)') '      integer, parameter :: dp=kind(1.d0), '
     &                                              //'nc2=ncls**2-1'
      write(unit,'(a)') '      complex(dp), parameter :: '//
     &                  'ocom=(0.d0,0.d0),'
      write(unit,'(a)') '     &                          '//
     &                  'onec=(1.d0,0.d0),'
      write(unit,'(a)') '     &                          '//
     &                  'icom=(0.d0,1.d0)'
      write(unit,'(a)') '      complex(dp) :: cfd(rdgs), '//
     &                  't(nc2,ncls,ncls),'
      write(unit,'(a)') '     &                          '//
     &                  'f(nc2,nc2,nc2)'
      write(unit,'(a)') '      real(dp) :: d(ncls,ncls)'
      write(unit,'(a)') '      real(dp), dimension(rdgs,rdgs) :: cfd2'
      write(unit,'(a)') ' '

c      write(unit,'(a)') '      include ''su3mats.f'''
      write(unit,'(a)') 'c SU(3) group generators and structure '//
     &                  'constants:'

      write(unit,'(a)') ' '
      write(unit,'(a)') '      t(1,1,:)=(/ ocom, onec, ocom/)'
      write(unit,'(a)') '      t(1,2,:)=(/ onec, ocom, ocom/)'
      write(unit,'(a)') '      t(1,3,:)=(/ ocom, ocom, ocom/)'

      write(unit,'(a)') ' '
      write(unit,'(a)') '      t(2,1,:)=(/ ocom,-icom, ocom/)'
      write(unit,'(a)') '      t(2,2,:)=(/ icom, ocom, ocom/)'
      write(unit,'(a)') '      t(2,3,:)=(/ ocom, ocom, ocom/)'

      write(unit,'(a)') ' '
      write(unit,'(a)') '      t(3,1,:)=(/ onec, ocom, ocom/)'
      write(unit,'(a)') '      t(3,2,:)=(/ ocom,-onec, ocom/)'
      write(unit,'(a)') '      t(3,3,:)=(/ ocom, ocom, ocom/)'

      write(unit,'(a)') ' '
      write(unit,'(a)') '      t(4,1,:)=(/ ocom, ocom, onec/)'
      write(unit,'(a)') '      t(4,2,:)=(/ ocom, ocom, ocom/)'
      write(unit,'(a)') '      t(4,3,:)=(/ onec, ocom, ocom/)'

      write(unit,'(a)') ' '
      write(unit,'(a)') '      t(5,1,:)=(/ ocom, ocom,-icom/)'
      write(unit,'(a)') '      t(5,2,:)=(/ ocom, ocom, ocom/)'
      write(unit,'(a)') '      t(5,3,:)=(/ icom, ocom, ocom/)'

      write(unit,'(a)') ' '
      write(unit,'(a)') '      t(6,1,:)=(/ ocom, ocom, ocom/)'
      write(unit,'(a)') '      t(6,2,:)=(/ ocom, ocom, onec/)'
      write(unit,'(a)') '      t(6,3,:)=(/ ocom, onec, ocom/)'

      write(unit,'(a)') ' '
      write(unit,'(a)') '      t(7,1,:)=(/ ocom, ocom, ocom/)'
      write(unit,'(a)') '      t(7,2,:)=(/ ocom, ocom,-icom/)'
      write(unit,'(a)') '      t(7,3,:)=(/ ocom, icom, ocom/)'

      write(unit,'(a)') ' '
      write(unit,'(a)') '      t(8,1,:)=(/ onec, ocom, ocom/)'//
     &                  '/sqrt(3.d0)'
      write(unit,'(a)') '      t(8,2,:)=(/ ocom, onec, ocom/)'//
     &                  '/sqrt(3.d0)'
      write(unit,'(a)') '      t(8,3,:)=(/ ocom, ocom,-2.d0*onec/)'//
     &                  '/sqrt(3.d0)'

      write(unit,'(a)') ' '
      write(unit,'(a)') '      t=t/2.d0'

      write(unit,'(a)') ' '
      write(unit,'(a)') '      f=0.d0'

      write(unit,'(a)') ' '
      write(unit,'(a)') '      f(1,2,3)=1.d0'
      write(unit,'(a)') '      f(1,4,7)=0.5d0'
      write(unit,'(a)') '      f(2,4,6)=0.5d0'
      write(unit,'(a)') '      f(2,5,7)=0.5d0'
      write(unit,'(a)') '      f(3,4,5)=0.5d0'
      write(unit,'(a)') '      f(1,5,6)=-0.5d0'
      write(unit,'(a)') '      f(3,6,7)=-0.5d0'
      write(unit,'(a)') '      f(4,5,8)=sqrt(3.d0)/2.d0'
      write(unit,'(a)') '      f(6,7,8)=sqrt(3.d0)/2.d0'

      write(unit,'(a)') ' '
      write(unit,'(a)') '      do i1=1,nc2'
      write(unit,'(a)') '       do i2=i1,nc2'
      write(unit,'(a)') '        do i3=i2,nc2'

      write(unit,'(a)') '         if (f(i1,i2,i3) /= 0.d0) then'
      write(unit,'(a)') '          f(i1,i3,i2)=-f(i1,i2,i3)'
      write(unit,'(a)') '          f(i2,i1,i3)=-f(i1,i2,i3)'
      write(unit,'(a)') '          f(i2,i3,i1)=f(i1,i2,i3)'
      write(unit,'(a)') '          f(i3,i1,i2)=f(i1,i2,i3)'
      write(unit,'(a)') '          f(i3,i2,i1)=-f(i1,i2,i3)'
      write(unit,'(a)') '         end if'
      write(unit,'(a)') '        end do'
      write(unit,'(a)') '       end do'
      write(unit,'(a)') '      end do'

      write(unit,'(a)') ' '
      write(unit,'(a)') '      f=icom*f'
      write(unit,'(a)') ' '
      write(unit,'(a)') ' '
      write(unit,'(a)') '      d=0.d0'
      write(unit,'(a)') '      cfd2=0.d0'
      write(unit,'(a)') ' '
      write(unit,'(a)') '      do j=1,ncls'
      write(unit,'(a)') '       d(j,j)=1.d0'
      write(unit,'(a)') '      end do'
      write(unit,'(a)') ' '

      do i=1,next
       if (f(i)%ct > 1) then
        write(ind1,'(i16)') i
        write(ind2,'(i16)') f(i)%ct
        write(unit,'(a)') '      do i'//trim(adjustl(ind1))
     &                         //'=1,'//trim(adjustl(ind2))
       end if
      end do
      write(unit,'(a)') ' '

      write(unit,'(a)') '      cfd=ocom'
      write(unit,'(a)') ' '

      end subroutine begincolsq
