      subroutine calcdis(p,cross)
c----------------------------------------------------------------------c
c Calculates distributions
c
c Input:  p - particle momenta,
c         cross - corresponding cross section.
c Select the number 'ndist' of distributions to be calculated and
c adjust the maximum number of bins 'nbmax' in 'distribs.f'
c
c Karol Kolodziej, University of Silesia, kolodzie@us.edu.pl
c 31 October, 2008, modiffied on 
c----------------------------------------------------------------------c
      use mathprms 
      use inprms
      use drivekk
      use distribs
      use partcls

      implicit none

      integer :: i,j,k,imxup=0
      real(dp) :: cross,p(0:3,nepl),p478(0:3)
      real :: rand
      character(80) ind
      save imxup

      if (idisn == 1) then
       idisn=0
       nbs=0
       xmin=0.d0
       xmax=0.d0
c Distrbution 1:
       desc(1)='Invariant mass squared of particles 4, 7 and 8'
       nbs(1)=160
       xmin(1)=mt-5.d0*gamt
       xmax(1)=mt+5.d0*gamt
c Distrbution 2:
       desc(2)='Cosine of the b-quark angle with respect to e+'
       nbs(2)=80
       xmin(2)=-1.d0
       xmax(2)=1.d0
c Distrbution 3:
       desc(3)='Energy of the b-quark'
       nbs(3)=60
       xmin(3)=0.d0
       xmax(3)=ecm/2.d0

       do j=1,ndist
        if (nbs(j) > 0) then
         xdi(0,j)=xmin(j)
         dx(:,j)=(xmax(j)-xmin(j))/nbs(j)
         do i=1,nbs(j)
          xdi(i,j)=xdi(i-1,j)+dx(i,j)
         end do
        else
         exit
        end if
       end do

      end if

      p478=p(:,4)+p(:,7)+p(:,8)
      xd(1)=sqrt((p478(0)-p478(3))*(p478(0)+p478(3))-p478(1)*p478(1)
     &                                         -p478(2)*p478(2))
      xd(2)=p(3,3)/sqrt(p(1,3)**2+p(2,3)**2+p(3,3)**2)
      xd(3)=p(0,3)

      do j=1,ndist
       if (nbs(j) > 0) then
        if (xd(j) >= xmin(j) .and. xd(j) <= xmax(j)) then
         do i=1,nbs(j)
          if (xd(j) <= xdi(i,j)) then
           ibin(j)=i
           ncs(i,j)=ncs(i,j)+1

           if (imc > 0) then
            if (imc == j) then
c             if (cross > cdmax(i)) then
             if (cross-cdmax(i) > 1.d-14*cdmax(i)) then
              cdmax(i)=cross
              itmax(i)=iit
              imxdif=1
              imxup=1
             end if
c             call random_number(rand)
             call ranlux(rand,1)
             if (cross > rand*cdmax(i)) then
              ieff=ieff+1
              ncsa(i)=ncsa(i)+1
              if (imxup == 1) then
               close(11)
               write(ind,'(f10.1)') ecm
               open(unit=11,file='mc_events.'//trim(adjustl(ind)),
     &                            status='replace',action='write')
               imxup=0
               ieff=0
              else
               write(11,'(a,i16)') '# Event No. ',ieff
               do k=nisp+1,nepl
                write(11,'(a,i2,a,4(e16.8))') 'p(',k,')=',p(:,k)
               end do
              end if
             end if
            end if
           end if
           exit
          end if
         end do
        else
         ibin(j)=0
        end if
       else
        exit
       end if
      end do

      end
