      module inprms

      use mathprms

      real(dp), parameter ::  
     &     mz=91.1882d0,  gamz=2.4952d0, ! Z mass and width
     &     mw=80.419d0,   !gamw=2.12d0,  ! W mass and width
     &     ialph0=137.03599911d0, ! an inverse of alpha in the Thomson limit
     &     gmu=1.16639d-5,        ! the Fermi coupling constant
     &     mh=115.d0              ! Higgs mass

c Photon and gluon masses and widths

      real(dp), parameter :: ma=zero, gama=zero,
     &                       mg=zero, gamg=zero

c Fermion masses:

      real(dp), parameter :: 
     &       me=0.51099892d-3, mmu=105.658369d-3, mtau=1.77699d0,
c     &       me=0.d0, mmu=0.d0, mtau=1.77699d0,
     &       mu=5.d-3, md=9.d-3, ms=150.d-3, 
c     &       mu=0.d0, md=0.d0, ms=0.d0, 
     &       mc=1.3d0, mb=4.8d0, mt=174.3d0, 
     &       alphas=0.1176d0, ! at mz
     &       sqscut=1.d-3 ! an invariant mass cut, used in mappings of 
                          ! the photon and gluon propagators that couple 
                          ! to massless fermions relevant if light fermion
                          ! masses are zero

c Fermion widths:

      real(dp), parameter :: 
     &       game=zero       , gammu=zero       , gamtau=zero,
     &       gamu=zero       , gamc=zero        , 
     &       gamd=zero       , gams=zero        , gamb=zero

      real(dp) :: gamt=zero, gamh=zero, gamw=2.12d0

c No of colours:

      real(dp), parameter :: ncol=3.d0

c Conversion costant (pb*GeV^2):

      real(dp), parameter ::   convc=0.389379323d9

c EW mixing parameter:

      real(dp), parameter ::   sw2=1.d0-(mw/mz)**2,
     &   ialphw=pi/(sqrt2*sw2*gmu*mw**2)            ! This is exactly the Gmu scheme

      real(dp) :: ralpw0

      end module inprms

